clear
%dati
R=6; %righe 
C=6; %colonne
ebn0dB=4:8; %SNR normalizzati
iterations=2; %soft decoding

Nblmax=5000000; %numero blocchi max
ermin=100; %numero minimo errori per snr
interval=50000;%intervallo visualizzazione

%parametri
Nbi=(R+1)*(C+1);
Kbi=R*C;
Ns=length(ebn0dB); %numero rapporti SNR
Rc=Kbi/Nbi; %tasso del codice
eavn0=Rc*10.^(ebn0dB/10);
varnoise=1./(2*eavn0);

eh=zeros(1,Ns);
Nbh=zeros(1,Ns);
es=zeros(1,Ns);
ebs=zeros(1,Ns);
Nbs=zeros(1,Ns);

for i=1:Ns
    %hard decoding
    while eh(i)<ermin && Nbh(i)<Nblmax
        Nbh(i)=Nbh(i)+1;
        noise=(varnoise(i)^.5)*randn(1,Nbi);
        eh(i)=eh(i)+(sum(noise<-1)>1);
        if rem(Nbh(i),interval)==0        
            res=sprintf('ebn0dB %.1f, blocks %6d, hard errors %3d, error rate:%.2e', ebn0dB(i),Nbh(i),eh(i),eh(i)/Nbh(i)); disp(res);
        end
    end
    %soft decoding
    while es(i)<ermin && Nbs(i)<Nblmax
        Nbs(i)=Nbs(i)+1;
        noise=(varnoise(i)^.5)*randn(R+1,C+1);
        y=noise+1;
        llrs=4*y*eavn0(i)^0.5;
        it=0;
        while it<iterations && (sum(sum(llrs<0))>0)
            it=it+1;
            for ir=1:R+1 
                temp=tanh(llrs/2); 
                temp(ir,:)=1; 
                px(ir,:)=2*atanh(prod(temp,1)); 
            end 
            llrs=llrs+px;
            for ic=1:C+1 
                temp=tanh(llrs/2); 
                temp(:,ic)=1; 
                px(:,ic)=2*atanh(prod(temp,2)); 
            end 
            llrs=llrs+px;
        end
        es(i)=es(i)+(sum(sum(llrs<0))>0);
        ebs(i)=ebs(i)+sum(sum(llrs<0));
        if rem(Nbs(i),interval)==0
            res=sprintf('ebn0dB %.1f, blocks %6d, soft errors %3d, error rate:%.2e', ebn0dB(i),Nbs(i),es(i),es(i)/Nbs(i)); disp(res);
        end
    end
end
pwss=es./Nbs;
pwhs=eh./Nbh;
pbss=ebs./(Nbs*Nbi);
pb=1/2*erfc(eavn0.^.5);
pwht=1-((1-pb).^Nbi+Nbi*pb.*(1-pb).^(Nbi-1));
dmin=4;Ndmin=R*(R+1)*C*(C+1)/4;
pwst=Ndmin/2*erfc((dmin*eavn0).^.5);
pbst=pwst*dmin/Nbi;
figure
semilogy(ebn0dB,pwht,'k');
hold on
semilogy(ebn0dB,pwhs,'k:o');
semilogy(ebn0dB,pwst,'r');
semilogy(ebn0dB,pwss,'r:o');
xlabel('ebn0dB')
ylabel('B.L.E.R.')
figure
semilogy(ebn0dB,pb,'k');
hold on
semilogy(ebn0dB,pbst,'r');
semilogy(ebn0dB,pbss,'r:o');
xlabel('ebn0dB')
ylabel('B.E.R.')

